<template>
  <div class="profile-page">
    <profile-basic-card
      class="profile-card"
      :user="user"
      :loading="loading"
      :editable="!this.id"
    />
    <div class="information-card-container">
      <personal-information-card
        class="profile-card"
        :user="user"
        :loading="loading"
        :editable="!this.id"
      />
      <abeuni-information-card
        class="profile-card"
        :user="user"
        :loading="loading"
        :editable="!this.id"
      />
    </div>
  </div>
</template>

<script lang="ts">
import Vue from 'vue'
import ProfileBasicCard from '@/components/profile-page/ProfileBasicCard.vue'
import PersonalInformationCard from '@/components/profile-page/PersonalInformationCard.vue'
import AbeuniInformationCard from '@/components/profile-page/AbeuniInformationCard.vue'
import { get } from '../util/http'

export default Vue.extend({
  name: 'profile-page',
  components: {
    ProfileBasicCard,
    PersonalInformationCard,
    AbeuniInformationCard
  },
  data () {
    return {
      loading: true,
      user: null as unknown
    }
  },
  mounted () {
    if (!this.auth0Loading) this.loadUser()
  },
  computed: {
    id () {
      return this.$route.params.id
    },
    auth0Loading () {
      return this.$auth.loading
    }
  },
  watch: {
    async auth0Loading () {
      this.loadUser()
    }
  },
  methods: {
    async loadUser () {
      const userResponse = await get(this.id ? `user/${this.id}` : 'user')
      this.user = userResponse.data

      console.log(userResponse)

      this.loading = false
    }
  }
})
</script>

<style lang="scss">
.profile-page {
  display: flex;
  flex-direction: column;

  .profile-card {
    flex: 1;
    margin: 0.5em;
  }
}

.information-card-container {
  display: flex;
  width: 100%;
}
</style>
